
/******************************************************************
  (C) Copyright 2001 by UNITED BYTES
   
  web:  http://www.unitedbytes.de
        http://www.unitedbytes.org
		http://www.unitedbytes.net
  mail: info@unitedbytes.de

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, 
  Boston, MA  02111-1307, USA.

  *****************************************************************

  Program:      ubNetwork
  File:         sources/cub_n_client.h
  Author:       Andreas Loeffler
  Date:         Mon, 10.04.2001
  Version:      1.0
  Description:  Client base class for internet applications

  -----------------------------------------------------------------

  Changes:		-
  Date:			-
  Description:	-

  *****************************************************************/

#ifndef __CUB_NETWORK_CLIENT_H__
#define __CUB_NETWORK_CLIENT_H__

#include <stdio.h>

#include "cub_n_socket.h"

// Global network length defines
#define CUB_NETWORK_MAXTEXT				255

// Global network states
#define CUB_NS_NOT_INITIALIZED			0
#define CUB_NS_WINSOCK_INIT				1
#define CUB_NS_SOCKET_CREATED			2
#define CUB_NS_CONNECTED				3

class CUB_Client
{
	public:
							CUB_Client ();
						   ~CUB_Client ();
		bool				Initialize ();
		bool				Shutdown		();
		bool				Connect			();
		bool				CloseConnection ();
		bool				GetLocalIP      (char *cBuffer);
		bool				Setup			(char *cServerIP, int iPort);
		bool				IsConnected		();
		bool				CreateSocket    ();

		char				m_cErrorText [CUB_NETWORK_MAXTEXT];
		CUB_Socket			m_Socket;
		int					m_iInitLevel;

	private:
		char				m_cServerIP [CUB_NETWORK_MAXTEXT];
		int					m_iServerPort;
		int					m_iClientID;
};

#endif