
/******************************************************************
  (C) Copyright 2001 by UNITED BYTES
   
  web:  http://www.unitedbytes.de
        http://www.unitedbytes.org
		http://www.unitedbytes.net
  mail: info@unitedbytes.de

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, 
  Boston, MA  02111-1307, USA.

  *****************************************************************

  Program:      ubNetwork
  File:         sources/cub_pop_client.h
  Author:       Andreas Loeffler
  Date:         Mon, 10.04.2001
  Version:      1.0
  Description:  Header file for pop client implementation (RFC 1939) 

  -----------------------------------------------------------------

  Changes:		-
  Date:			-
  Description:	-

  *****************************************************************/

#ifndef __CUB_POP_CLIENT_H__
#define __CUB_POP_CLIENT_H__

#include "cub_n_client.h"
#include "cub_pop_baseclass.h"

struct CUB_popClientInfo 
{
	char m_cMailboxName [CUB_POP_MAX_ARGUMENT];
	char m_cPassword    [CUB_POP_MAX_ARGUMENT];
	char m_cPopServer	[CUB_POP_MAX_ARGUMENT];
	long m_lServerPort;
};

class CUB_popClient : public CUB_Client, CUB_popBaseClass
{
	public:
							CUB_popClient ();
						   ~CUB_popClient ();

		bool				ConnectToPOP3		 (CUB_popClientInfo *pClientInfo);
		void				Shutdown			 ();
		long				ReceiveServerMessage (char *cBuffer, long lBufLen);
		bool				SendServerMessage    (char *cBuffer, long lBufLen);
		bool				SendCommand			 (char *cCommand);
		bool				CommandValid		 (char *cCommand);
		bool				MessageManager		 ();
		
		long				GetNumMessages       ();
		long				GetSizeOfMessages    ();

	private:
		long				m_lNumMessages;
		long				m_lSizeOfMessages;

};

#endif